package de.unima.crumbtrail;

import de.unima.crumbtrail.pruner.CrumbTrail;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;
import org.jgrapht.alg.ConnectivityInspector;
import org.jgrapht.alg.CycleDetector;

import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.graph.DefaultEdge;

/**
 *
 * @author sfaralli
 */
public class TestCrumbTrail {

    public static long count = 0;

 /**
 * NOTE: this is a prototype implementation 
 *       we are working hard to produce and release an optimized and documented version soon. 
 * @author sfaralli
 */
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException, FileNotFoundException, ClassNotFoundException, InterruptedException {

        int testnum =14; //change from 0 to 14 
        try {
            DefaultDirectedGraph<String, DefaultEdge> test = getTestGraph(testnum);
            printStats(test);

            System.out.println("****ORIGINAL*****");
            for (DefaultEdge de : test.edgeSet()) {
                System.out.println(test.getEdgeSource(de) + ";" + test.getEdgeTarget(de));
            }
            Set<String> good = getTestGood(testnum);
            Set<String> K = getTestK(testnum);
            System.out.println("****TREE*****");
            CrumbTrail.prune("data/website/test" + testnum + "/state", true, false, true, false, test, getRoot(testnum), good, K, "pruningTEST" + testnum + ".out", "test_" + testnum, "test_" + testnum, "G", false, true);
            CrumbTrail.saveGraph(test, "pruningTEST" + testnum + ".tsv");
            System.out.println("****pruned*****");
            for (DefaultEdge de : test.edgeSet()) {
                System.out.println(test.getEdgeSource(de) + ";" + test.getEdgeTarget(de));
            }
            printStats(test);
        } catch (IOException | InterruptedException e) {
            e.printStackTrace();
        }

    }

    public static Set<String> getTestGood(int index) {
        Set<String> result = new HashSet<>();
        switch (index) {
            case 0:
                result.add("g1");
                result.add("g2");
                break;
            case 1:
                result.add("g1");
                result.add("g2");
                break;
            case 2:
                result.add("g1");
                result.add("g2");
                result.add("g3");
                result.add("g4");
                break;
            case 3:
                result.add("g1");
                result.add("g2");
                result.add("g3");
                result.add("g4");
                break;

            case 4:
                result.add("g1");
                result.add("g2");
                break;
            case 5:
                result.add("g1");
                result.add("g2");
                break;
            case 6:
                result.add("g1");
                result.add("g2");
                result.add("g3");
                break;
            case 7:
                result.add("g1");
                break;
            case 8:
                result.add("g1");
                result.add("g2");
                result.add("g3");
                break;
            case 9:
                result.add("a");
                result.add("b");
                result.add("c");
                result.add("f");
                break;
            case 10:
                result.add("a");
                result.add("b");
                result.add("c");
                result.add("d");
                break;
            case 11:
                result.add("a");
                result.add("b");
                result.add("c");
                result.add("d");
                break;
            case 12:
                result.add("a");
                break;

            case 13:
                result.add("1");
                result.add("2");
                result.add("3");
                break;
            case 14:
                result.add("g1");
                result.add("g2");
                break;
            default:
                break;
        }
        return result;
    }

    public static Set<String> getTestK(int index) {
        Set<String> result = new HashSet<>();
        switch (index) {
            case 0:
                break;
            case 1:
                break;
            case 2:
                break;
            case 3:
                break;

            case 4:
                break;
            case 5:
                break;
            case 6:
                break;
            case 7:
                break;
            case 8:
                break;
            case 9:
                result.add("d");
                result.add("e");
                break;
            case 10:
                result.add("e");
                break;
            case 11:
                result.add("e");
                break;
            case 12:
                result.add("b");
                result.add("c");
                result.add("d");
                result.add("e");
                result.add("f");
                result.add("g");
                break;
            default:
                break;
        }
        return result;
    }

    public static String getRoot(int index) {
        String result = "";
        switch (index) {
            case 0:
                result = "R";
                break;
            case 1:
                result = "R";
                break;
            case 2:
                result = "R";
                break;
            case 3:
                result = "R";
                break;
            case 4:
                result = "R";
                break;
            case 5:
                result = "R";
                break;
            case 6:
                result = "R";
                break;
            case 7:
                result = "R";
                break;
            case 8:
                result = "R";
                break;
            case 9:
                result = "R";
                break;
            case 10:
                result = "R";
                break;
            case 11:
                result = "R";
                break;
            case 12:
                result = "R";
                break;
            case 13:
                result = "R";
                break;
            case 14:
                result = "R";
                break;

            default:
                break;
        }
        return result;
    }

    public static DefaultDirectedGraph<String, DefaultEdge> getTestGraph(int index) {

        DefaultDirectedGraph<String, DefaultEdge> result = new DefaultDirectedGraph<String, DefaultEdge>(DefaultEdge.class);

        switch (index) {
            case 0:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("g1");
                result.addVertex("g2");
                result.addEdge("R", "a");
                result.addEdge("a", "b");
                result.addEdge("b", "g1");
                result.addEdge("b", "g2");

                break;
            case 1:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("g1");
                result.addVertex("g2");

                result.addEdge("R", "a");
                result.addEdge("R", "b");
                result.addEdge("R", "c");
                result.addEdge("a", "g1");
                result.addEdge("a", "g2");

                result.addEdge("b", "g1");
                result.addEdge("c", "g1");

                break;

            case 2:
                result.addVertex("R");
                result.addVertex("C3_1");
                result.addVertex("C3_2");
                result.addVertex("C3_3");
                result.addVertex("C2_1");
                result.addVertex("C2_2");
                result.addVertex("C2_3");
                result.addVertex("C2_4");
                result.addVertex("C1_1");
                result.addVertex("C1_2");
                result.addVertex("C1_3");
                result.addVertex("C1_4");
                result.addVertex("C1_5");
                result.addVertex("C1_6");

                result.addVertex("g1");
                result.addVertex("g2");
                result.addVertex("g3");
                result.addVertex("g4");

                result.addVertex("b1");
                result.addVertex("b2");
                result.addVertex("b3");

                result.addEdge("R", "C3_1");
                result.addEdge("R", "C3_2");
                result.addEdge("R", "C3_3");

                result.addEdge("C3_1", "C2_1");
                result.addEdge("C3_1", "C2_2");

                result.addEdge("C1_3", "C2_3");
                result.addEdge("C2_3", "C3_1");

                result.addEdge("C3_2", "C2_2");

                result.addEdge("C3_2", "C2_3");
                result.addEdge("C3_3", "C2_3");
                result.addEdge("C3_3", "C2_4");

                result.addEdge("C2_1", "C1_1");
                result.addEdge("C2_1", "C1_2");
                result.addEdge("C2_1", "C1_3");

                result.addEdge("C2_2", "C1_2");
                result.addEdge("C2_2", "C1_3");
                result.addEdge("C2_2", "C1_4");

                result.addEdge("C2_3", "C1_3");
                result.addEdge("C2_3", "C1_4");
                result.addEdge("C2_3", "C1_5");

                result.addEdge("C2_4", "C1_4");
                result.addEdge("C2_4", "C1_5");
                result.addEdge("C2_4", "C1_6");

                result.addEdge("C1_1", "b1");
                result.addEdge("C1_1", "b2");
                result.addEdge("C1_2", "b2");
                result.addEdge("C1_6", "b3");

                result.addEdge("C1_1", "g4");
                result.addEdge("C1_2", "g1");
                result.addEdge("C1_2", "g2");
                result.addEdge("C1_4", "g2");
                result.addEdge("C1_4", "g3");
                result.addEdge("C1_5", "g3");
                result.addEdge("C1_5", "g4");

                break;
            case 3:
                result.addVertex("R");
                result.addVertex("C3_1");
                result.addVertex("C3_2");
                result.addVertex("C3_3");
                result.addVertex("C2_1");
                result.addVertex("C2_2");
                result.addVertex("C2_3");
                result.addVertex("C2_4");
                result.addVertex("C1_1");
                result.addVertex("C1_2");
                result.addVertex("C1_3");
                result.addVertex("C1_4");
                result.addVertex("C1_5");
                result.addVertex("C1_6");

                result.addVertex("g1");
                result.addVertex("g2");
                result.addVertex("g3");
                result.addVertex("g4");
                result.addVertex("b1");
                result.addVertex("b2");
                result.addVertex("b3");
                result.addEdge("R", "C3_1");
                result.addEdge("R", "C3_2");
                result.addEdge("R", "C3_3");

                result.addEdge("C3_1", "C2_1");
                result.addEdge("C3_1", "C2_2");

                result.addEdge("C3_2", "C2_2");
                result.addEdge("C3_2", "C2_3");

                result.addEdge("C3_3", "C2_3");
                result.addEdge("C3_3", "C2_4");

                result.addEdge("C2_1", "C1_1");
                result.addEdge("C2_1", "C1_2");
                result.addEdge("C2_1", "C1_3");

                result.addEdge("C2_2", "C1_2");
                result.addEdge("C2_2", "C1_3");
                result.addEdge("C2_2", "C1_4");

                result.addEdge("C2_3", "C3_1");
                result.addEdge("C2_3", "C1_3");
                result.addEdge("C2_3", "C1_4");
                result.addEdge("C2_3", "C1_5");

                result.addEdge("C2_4", "C1_4");
                result.addEdge("C2_4", "C1_5");
                result.addEdge("C2_4", "C1_6");

                result.addEdge("C1_1", "g4");
                result.addEdge("C1_1", "b2");
                result.addEdge("C1_3", "g4");
                result.addEdge("C1_2", "g1");
                result.addEdge("C1_2", "g2");
                result.addEdge("C1_4", "g2");
                result.addEdge("C1_4", "g3");
                result.addEdge("C1_5", "g3");
                result.addEdge("C1_5", "g4");

                break;

            case 4:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");

                result.addVertex("c");
                result.addVertex("g1");
                result.addVertex("g2");
                result.addVertex("b1");

                result.addEdge("R", "a");
                result.addEdge("a", "b");
                result.addEdge("b", "c");
                result.addEdge("c", "g1");
                result.addEdge("c", "g2");
                result.addEdge("a", "b1");

                break;

            case 5:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("d");
                result.addVertex("g1");
                result.addVertex("g2");
                result.addVertex("b1");
                result.addVertex("b2");
                result.addEdge("R", "a");
                result.addEdge("a", "b");
                result.addEdge("a", "d");
                result.addEdge("d", "g1");
                result.addEdge("d", "b");
                result.addEdge("b", "c");
                result.addEdge("c", "g1");
                result.addEdge("c", "g2");
                result.addEdge("a", "b1");
                result.addEdge("a", "b2");

                break;
            case 6:

                result.addVertex("R");
                result.addVertex("1");
                result.addVertex("2");
                result.addVertex("3");
                result.addVertex("4");
                result.addVertex("5");
                result.addVertex("6");
                result.addVertex("7");
                result.addVertex("8");
                result.addVertex("9");
                result.addVertex("g1");
                result.addVertex("g2");
                result.addVertex("g3");
                result.addVertex("b1");

                result.addEdge("R", "g1");
                result.addEdge("R", "1");
                result.addEdge("R", "2");
                result.addEdge("1", "2");
                result.addEdge("2", "3");
                result.addEdge("2", "9");
                result.addEdge("3", "9");
                result.addEdge("3", "g2");
                result.addEdge("1", "4");
                result.addEdge("4", "5");
                result.addEdge("5", "1");
                result.addEdge("5", "6");
                result.addEdge("6", "3");
                result.addEdge("6", "7");
                result.addEdge("7", "8");
                result.addEdge("7", "5");
                result.addEdge("8", "5");
                result.addEdge("6", "4");
                result.addEdge("6", "g3");
                result.addEdge("3", "b1");
                break;
            case 7:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("d");
                result.addVertex("g1");
                result.addEdge("R", "a");
                result.addEdge("a", "b");
                result.addEdge("b", "c");
                result.addEdge("c", "d");
                result.addEdge("d", "g1");
                // result.addEdge("a","c");
                result.addEdge("d", "a");
                result.addEdge("b", "d");
                //result.addEdge("d","b");
                result.addEdge("d", "a");
                break;

            case 8:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("g1");
                result.addVertex("g2");
                result.addVertex("g3");

                result.addEdge("R", "a");
                result.addEdge("a", "b");
                result.addEdge("b", "c");
                result.addEdge("c", "g1");
                result.addEdge("b", "g2");
                result.addEdge("a", "g3");
                result.addEdge("a", "c");
                result.addEdge("b", "a");
                break;

            case 9:
                result.addVertex("R");
                result.addVertex("1");
                result.addVertex("2");
                result.addVertex("3");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("f");
                result.addVertex("4");
                result.addVertex("d"); //d1
                result.addVertex("5");
                result.addVertex("6");

                result.addVertex("e"); //ee
                result.addVertex("7");
                result.addVertex("8");
                result.addVertex("9");
                result.addVertex("10");

                result.addVertex("11");
                result.addVertex("12");
                result.addVertex("13");
                result.addVertex("14");
                result.addVertex("15");

                result.addEdge("R", "1");
                result.addEdge("R", "12");
                result.addEdge("12", "13");
                result.addEdge("13", "c");

                result.addEdge("R", "14");
                result.addEdge("14", "15");
                result.addEdge("15", "c");

                result.addEdge("1", "2");
                result.addEdge("2", "3");
                result.addEdge("3", "c");
                result.addEdge("2", "b");
                result.addEdge("a", "1");
                result.addEdge("1", "a");
                result.addEdge("1", "3");
                result.addEdge("2", "1");

                result.addEdge("4", "d");
                result.addEdge("d", "4");
                result.addEdge("4", "5");
                result.addEdge("5", "4");
                result.addEdge("4", "6");
                result.addEdge("6", "4");
                result.addEdge("7", "e");
                result.addEdge("e", "7");
                result.addEdge("9", "e");
                result.addEdge("e", "9");
                result.addEdge("8", "e");
                result.addEdge("e", "8");

                result.addEdge("R", "7");
                result.addEdge("R", "8");
                result.addEdge("R", "9");

                result.addEdge("R", "4");

                result.addEdge("e", "3");
                result.addEdge("d", "2");
                result.addEdge("5", "2");
                result.addEdge("6", "2");

                result.addEdge("5", "6");
                result.addEdge("7", "8");
                result.addEdge("9", "8");
                result.addEdge("1", "d");
                result.addEdge("3", "6");
                result.addEdge("c", "f");
                result.addEdge("f", "3");
                result.addEdge("1", "R");
                result.addEdge("b", "11");
                result.addEdge("10", "9");

                result.addEdge("3", "3");
                result.addEdge("d", "d");

                break;

            case 10:
                result.addVertex("R");
                result.addVertex("1");
                result.addVertex("2");
                result.addVertex("3");

                result.addVertex("4");
                result.addVertex("5");
                result.addVertex("6");

                result.addVertex("7");
                result.addVertex("8");
                result.addVertex("9");
                result.addVertex("10");
                result.addVertex("11");
                result.addVertex("12");
                result.addVertex("13");
                result.addVertex("14");

                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("d");
                result.addVertex("e");

                result.addEdge("e", "13");
                result.addEdge("13", "2");
                result.addEdge("13", "3");
                result.addEdge("2", "4");
                result.addEdge("13", "2");
                result.addEdge("14", "4");
                result.addEdge("R", "7");
                result.addEdge("R", "e");
                result.addEdge("11", "7");

                result.addEdge("e", "8");
                result.addEdge("e", "3");
                result.addEdge("e", "4");
                result.addEdge("8", "4");
                result.addEdge("8", "9");
                result.addEdge("8", "6");
                result.addEdge("8", "7");
                result.addEdge("6", "8");

                result.addEdge("6", "a");
                result.addEdge("6", "b");
                result.addEdge("7", "6");
                result.addEdge("7", "a");
                result.addEdge("9", "5");

                result.addEdge("5", "b");
                result.addEdge("5", "12");
                result.addEdge("4", "5");
                result.addEdge("4", "2");
                result.addEdge("4", "14");
                result.addEdge("3", "14");
                result.addEdge("3", "2");

                result.addEdge("3", "1");

                result.addEdge("3", "10");

                result.addEdge("2", "12");
                result.addEdge("2", "c");

                result.addEdge("14", "12");
                result.addEdge("14", "c");

                result.addEdge("1", "c");
                result.addEdge("1", "d");
                result.addEdge("3", "3");
                result.addEdge("9", "9");

                break;

            case 11:
                result.addVertex("R");
                result.addVertex("1");
                result.addVertex("2");
                result.addVertex("3");

                result.addVertex("4");
                result.addVertex("5");
                result.addVertex("6");

                result.addVertex("7");
                result.addVertex("8");
                result.addVertex("9");
                result.addVertex("10");
                result.addVertex("11");
                result.addVertex("12");
                result.addVertex("13");
                result.addVertex("14");
                result.addVertex("15");

                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("d");
                result.addVertex("e");

                result.addEdge("R", "7");
                result.addEdge("R", "e");//

                result.addEdge("1", "c");
                result.addEdge("1", "d");

                result.addEdge("2", "12");//
                result.addEdge("2", "c");//
                result.addEdge("2", "e");
                result.addEdge("2", "4");//

                result.addEdge("3", "14");//
                result.addEdge("3", "2");//
                result.addEdge("3", "1");//
                result.addEdge("3", "10");//
                result.addEdge("3", "3");

                result.addEdge("4", "5");//
                result.addEdge("4", "2");//
                result.addEdge("4", "14");//
                result.addEdge("4", "d");

                result.addEdge("5", "b");//
                result.addEdge("5", "12");//

                result.addEdge("6", "8");//

                result.addEdge("6", "a");//
                result.addEdge("6", "b");//
                result.addEdge("6", "R");//

                result.addEdge("7", "6");
                result.addEdge("7", "a");//

                result.addEdge("8", "4");//
                result.addEdge("8", "9");//
                result.addEdge("8", "6");//
                result.addEdge("8", "7");//
                result.addEdge("8", "15");//

                result.addEdge("9", "9");
                result.addEdge("9", "5");//

                result.addEdge("11", "7");//

                result.addEdge("13", "2"); //
                result.addEdge("13", "3");//
                result.addEdge("13", "14");//

                result.addEdge("e", "13"); //

                result.addEdge("e", "8");//
                result.addEdge("e", "3");//
                result.addEdge("e", "4");//

                result.addEdge("d", "1");//

                result.addEdge("14", "12");//
                result.addEdge("14", "c");//
                result.addEdge("14", "4");//

                result.addEdge("15", "a");//
                result.addEdge("15", "b");//

                break;

            case 12:
                result.addVertex("R");

                result.addVertex("1");
                result.addVertex("2");
                result.addVertex("3");
                result.addVertex("4");
                result.addVertex("5");
                result.addVertex("6");

                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("d");
                result.addVertex("e");
                result.addVertex("f");
                result.addVertex("g");

                result.addEdge("1", "a"); //
                //ciclo
                result.addEdge("1", "6"); //
                result.addEdge("2", "1");//
                result.addEdge("3", "2");//
                result.addEdge("4", "3");//
                result.addEdge("5", "4");
                result.addEdge("6", "5");//

                result.addEdge("b", "1");//
                result.addEdge("g", "6");//
                result.addEdge("f", "5");//
                result.addEdge("e", "4");//
                result.addEdge("d", "3");//
                result.addEdge("c", "2");//

                result.addEdge("R", "b");//
                result.addEdge("R", "c");//

                result.addEdge("R", "d");//
                result.addEdge("R", "e");//

                result.addEdge("R", "f");//
                result.addEdge("R", "g");//

                break;
            case 13:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("c");
                result.addVertex("1");
                result.addVertex("2");
                result.addVertex("3");
                result.addEdge("R", "a");//
                result.addEdge("a", "1");//
                result.addEdge("a", "b");//
                result.addEdge("b", "c");//
                result.addEdge("c", "b");//
                result.addEdge("b", "2");//
                result.addEdge("c", "3");//

            case 14:
                result.addVertex("R");
                result.addVertex("a");
                result.addVertex("b");
                result.addVertex("g1");
                result.addVertex("g2");
                result.addEdge("R", "a");//
                result.addEdge("R", "b");//
                result.addEdge("a", "b");//
                result.addEdge("b", "a");//
                result.addEdge("a", "g1");//
                result.addEdge("b", "g2");//
            default:
                break;

        }
        return result;

    }

    public static boolean hasCycle(DefaultDirectedGraph<String, DefaultEdge> graph) {
        CycleDetector cd = new CycleDetector(graph);
        return cd.detectCycles();
    }

    public static int numberOfConnectedComponents(DefaultDirectedGraph<String, DefaultEdge> graph) {
        ConnectivityInspector<String, DefaultEdge> ci = new ConnectivityInspector<>(graph);
        return ci.connectedSets().size();
    }

    public static void printStats(DefaultDirectedGraph<String, DefaultEdge> graph) {
        System.out.println("***********************************************************");
        System.out.println("*|V|=" + graph.vertexSet().size());
        System.out.println("*|E|=" + graph.edgeSet().size());
        System.out.println("*#connectedcomponents =" + numberOfConnectedComponents(graph));
        System.out.println("*hasCycles=" + hasCycle(graph));
        System.out.println("***********************************************************");
    }
}
